## Sid Meier's Civilization 4
## Copyright Firaxis Games 2005
##
## Extra Xp by Zuul
##

from CvPythonExtensions import *
import CvUtil
import Popup as PyPopup
#import array

# globals
gc = CyGlobalContext()

class ExtraXp:
	def onUnitCreated(self, argsList):
		pUnit = argsList[0]
		
		if pUnit.canAcquirePromotionAny():
		
			promBerzerker1 = gc.getInfoTypeForString("PROMOTION_BERZERKER1")
			promBerzerker2 = gc.getInfoTypeForString("PROMOTION_BERZERKER2")
			promBerzerker3 = gc.getInfoTypeForString("PROMOTION_BERZERKER3")
			promStalwart1 = gc.getInfoTypeForString("PROMOTION_STALWART1")
			promStalwart2 = gc.getInfoTypeForString("PROMOTION_STALWART2")
			promStalwart3 = gc.getInfoTypeForString("PROMOTION_STALWART3")
			promHeavy = gc.getInfoTypeForString("PROMOTION_HEAVY")
			promLight1 = gc.getInfoTypeForString("PROMOTION_LIGHT1")
			promLight2 = gc.getInfoTypeForString("PROMOTION_LIGHT2")
			promHero1 = gc.getInfoTypeForString("PROMOTION_HERO1")
			promHero2 = gc.getInfoTypeForString("PROMOTION_HERO2")
			promHero3 = gc.getInfoTypeForString("PROMOTION_HERO3")
			promHero4 = gc.getInfoTypeForString("PROMOTION_HERO4")
			promHero5 = gc.getInfoTypeForString("PROMOTION_HERO5")
			promCombat1 = gc.getInfoTypeForString("PROMOTION_COMBAT1")
			promCombat2 = gc.getInfoTypeForString("PROMOTION_COMBAT2")
			promCombat3 = gc.getInfoTypeForString("PROMOTION_COMBAT3")
			promCombat4 = gc.getInfoTypeForString("PROMOTION_COMBAT4")
			promAttack1 = gc.getInfoTypeForString("PROMOTION_ATTACK1")
			promAttack2 = gc.getInfoTypeForString("PROMOTION_ATTACK2")
			promDefence1 = gc.getInfoTypeForString("PROMOTION_DEFENCE1")
			promDefence2 = gc.getInfoTypeForString("PROMOTION_DEFENCE2")
			promRaider1 = gc.getInfoTypeForString("PROMOTION_CITY_RAIDER1")
			promRaider2 = gc.getInfoTypeForString("PROMOTION_CITY_RAIDER2")
			promRaider3 = gc.getInfoTypeForString("PROMOTION_CITY_RAIDER3")
			promGarrison1 = gc.getInfoTypeForString("PROMOTION_CITY_GARRISON1")
			promGarrison2 = gc.getInfoTypeForString("PROMOTION_CITY_GARRISON2")			
			promGarrison3 = gc.getInfoTypeForString("PROMOTION_CITY_GARRISON3")
			promShock1 = gc.getInfoTypeForString("PROMOTION_SHOCK")
			promShock2 = gc.getInfoTypeForString("PROMOTION_SHOCK2")
			promCover1 = gc.getInfoTypeForString("PROMOTION_COVER")
			promCover2 = gc.getInfoTypeForString("PROMOTION_COVER2")
			promFormation1 = gc.getInfoTypeForString("PROMOTION_FORMATION")
			promFormation2 = gc.getInfoTypeForString("PROMOTION_FORMATION2")
			promCharge1 = gc.getInfoTypeForString("PROMOTION_CHARGE")
			promCharge2 = gc.getInfoTypeForString("PROMOTION_CHARGE2")
			promPinch1 = gc.getInfoTypeForString("PROMOTION_PINCH")
			promPinch2 = gc.getInfoTypeForString("PROMOTION_PINCH2")
			promAmbush1 = gc.getInfoTypeForString("PROMOTION_AMBUSH")
			promAmbush2 = gc.getInfoTypeForString("PROMOTION_AMBUSH2")
			promGuerilla1 = gc.getInfoTypeForString("PROMOTION_GUERILLA1")
			promGuerilla2 = gc.getInfoTypeForString("PROMOTION_GUERILLA2")
			promWoodsman1 = gc.getInfoTypeForString("PROMOTION_WOODSMAN1")
			promWoodsman2 = gc.getInfoTypeForString("PROMOTION_WOODSMAN2")
			promWarmth = gc.getInfoTypeForString("PROMOTION_WARMTH1")
			promCold = gc.getInfoTypeForString("PROMOTION_COLD1")
			promField = gc.getInfoTypeForString("PROMOTION_FIELD1")
			promAccuracy = gc.getInfoTypeForString("PROMOTION_ACCURACY")
			promBarrage1 = gc.getInfoTypeForString("PROMOTION_BARRAGE1")
			promBarrage2 = gc.getInfoTypeForString("PROMOTION_BARRAGE2")
			promDrill1 = gc.getInfoTypeForString("PROMOTION_DRILL1")
			promDrill2 = gc.getInfoTypeForString("PROMOTION_DRILL2")
			promDrill3 = gc.getInfoTypeForString("PROMOTION_DRILL3")
			promFlanking1 = gc.getInfoTypeForString("PROMOTION_FLANKING1")
			promFlanking2 = gc.getInfoTypeForString("PROMOTION_FLANKING2")
			promAmph = gc.getInfoTypeForString("PROMOTION_AMPHIBIOUS")
			promBlitz = gc.getInfoTypeForString("PROMOTION_BLITZ")
			
			promMedic1 = gc.getInfoTypeForString("PROMOTION_MEDIC1")
			promMedic2 = gc.getInfoTypeForString("PROMOTION_MEDIC2")
			promHeal = gc.getInfoTypeForString("PROMOTION_HEAL")
			promMarch = gc.getInfoTypeForString("PROMOTION_MARCH")
			promMobility = gc.getInfoTypeForString("PROMOTION_MOBILITY")
			promCommando = gc.getInfoTypeForString("PROMOTION_COMMANDO")
			promSpeed = gc.getInfoTypeForString("PROMOTION_SPEED")
			promNavigation = gc.getInfoTypeForString("PROMOTION_NAVIGATION1")
			promSentry = gc.getInfoTypeForString("PROMOTION_SENTRY")
			
			
			uctRecon = gc.getInfoTypeForString("UNITCOMBAT_RECON")
			uctArcher = gc.getInfoTypeForString("UNITCOMBAT_ARCHER")
			uctMounted = gc.getInfoTypeForString("UNITCOMBAT_MOUNTED")
			uctMelee = gc.getInfoTypeForString("UNITCOMBAT_MELEE")
			uctSiege = gc.getInfoTypeForString("UNITCOMBAT_SIEGE")
			uctGun = gc.getInfoTypeForString("UNITCOMBAT_GUN")
			uctArmor = gc.getInfoTypeForString("UNITCOMBAT_ARMOR")
			uctHeli = gc.getInfoTypeForString("UNITCOMBAT_HELICOPTER")
			uctNaval = gc.getInfoTypeForString("UNITCOMBAT_NAVAL")
			#uctRecon,uctArcher,uctMounted,uctMelee,uctSiege,uctGun,uctArmor,uctHeli,uctNaval
			
			uct = pUnit.getUnitCombatType()
			
			
			if uct != uctRecon:
				chance = CyGame().getSorenRandNum(100, "Random for attack/defence prom")
				if chance >= 98:
					pUnit.setHasPromotion(promStalwart3, true)
				elif chance >= 94:
					pUnit.setHasPromotion(promStalwart2, true)
				elif chance >= 86:
					pUnit.setHasPromotion(promStalwart1, true)
				elif chance >= 84:
					pUnit.setHasPromotion(promBerzerker3, true)
				elif chance >= 80:
					pUnit.setHasPromotion(promBerzerker2, true)
				elif chance >= 72:
					pUnit.setHasPromotion(promBerzerker1, true)
			
			chance = CyGame().getSorenRandNum(100, "Random for light/heavy prom")
			if chance >= 95:
				if pUnit.baseMoves() > 3:
					pUnit.setHasPromotion(promLight2, true)
				else:
					pUnit.setHasPromotion(promLight1, true)
			elif (chance >= 90) and (pUnit.baseMoves() > 1):
				pUnit.setHasPromotion(promHeavy, true)
			
			chance = CyGame().getSorenRandNum(500, "Random for hero prom")
			if chance >= 499:
				pUnit.setHasPromotion(promHero5, true)
			elif chance >= 497:
				pUnit.setHasPromotion(promHero4, true)
			elif chance >= 493:
				pUnit.setHasPromotion(promHero3, true)
			elif chance >= 485:
				pUnit.setHasPromotion(promHero2, true)
			elif chance >= 469:
				pUnit.setHasPromotion(promHero1, true)
				
			#Also if civ is  agressive (already has combat 1) it get other promotions
			chance = CyGame().getSorenRandNum(500, "Random for combat prom")
			if chance >= 499:
				if pUnit.isHasPromotion(promCombat1):
					pUnit.setHasPromotion(promCombat2, true)
					pUnit.setHasPromotion(promCombat3, true)
					pUnit.setHasPromotion(promCombat4, true)
				else:
					pUnit.setHasPromotion(promCombat1, true)
					pUnit.setHasPromotion(promCombat2, true)
					pUnit.setHasPromotion(promCombat3, true)
			elif chance >= 494:
				if pUnit.isHasPromotion(promCombat1):
					pUnit.setHasPromotion(promCombat2, true)
					pUnit.setHasPromotion(promCombat3, true)
				else:
					pUnit.setHasPromotion(promCombat1, true)
					pUnit.setHasPromotion(promCombat2, true)
			elif chance >= 469:
				if pUnit.isHasPromotion(promCombat1):
					pUnit.setHasPromotion(promCombat2, true)
				else:
					pUnit.setHasPromotion(promCombat1, true)
			
			chance = CyGame().getSorenRandNum(200, "Random for attack/defence prom")
			if chance >= 199:
				if (uct == uctMelee) or (uct == uctMounted) or (uct == uctArmor) or (uct == uctNaval):
					pUnit.setHasPromotion(promAttack1, true)
					pUnit.setHasPromotion(promAttack2, true)
			elif chance >= 196:
				if (uct != uctRecon) and (uct != uctSiege):
					pUnit.setHasPromotion(promAttack1, true)
			elif chance >= 195:
				if (uct == uctMelee) or (uct == uctArcher) or (uct == uctGun) or (uct == uctNaval):
					pUnit.setHasPromotion(promDefence1, true)
					pUnit.setHasPromotion(promDefence2, true)
			elif chance >= 191:
				if (uct == uctMelee) or (uct == uctArcher) or (uct == uctGun) or (uct == uctNaval):
					pUnit.setHasPromotion(promDefence1, true)
			
			chance = CyGame().getSorenRandNum(500, "Random for city raider/garrison prom")
			if chance >= 499:
				if (uct == uctArcher) or (uct == uctGun):
					pUnit.setHasPromotion(promGarrison1, true)
					pUnit.setHasPromotion(promGarrison2, true)
					pUnit.setHasPromotion(promGarrison3, true)
			elif chance >= 494:
				if (uct == uctArcher) or (uct == uctGun):
					pUnit.setHasPromotion(promGarrison1, true)
					pUnit.setHasPromotion(promGarrison2, true)
			elif chance >= 469:
				if (uct == uctMelee) or (uct == uctArcher) or (uct == uctGun):
					pUnit.setHasPromotion(promGarrison1, true)
			elif chance >= 468:
				if (uct == uctMelee) or (uct == uctSiege):
					pUnit.setHasPromotion(promRaider1, true)
					pUnit.setHasPromotion(promRaider2, true)
					pUnit.setHasPromotion(promRaider3, true)
			elif chance >= 463:
				if (uct == uctMelee) or (uct == uctSiege) or (uct == uctArmor):
					pUnit.setHasPromotion(promRaider1, true)
					pUnit.setHasPromotion(promRaider2, true)
			elif chance >= 438:
				if (uct == uctMelee) or (uct == uctMounted) or (uct == uctSiege) or (uct == uctGun) or (uct == uctArmor):
					pUnit.setHasPromotion(promRaider1, true)
			
			chance = CyGame().getSorenRandNum(200, "Random for shock prom")
			if chance >= 199:
				if (uct == uctMelee) or (uct == uctArcher) or (uct == uctMounted) or (uct == uctSiege):
					pUnit.setHasPromotion(promShock1, true)
					pUnit.setHasPromotion(promShock2, true)
			elif chance >= 195:
				if (uct == uctMelee) or (uct == uctArcher) or (uct == uctMounted):
					pUnit.setHasPromotion(promShock1, true)
			
			chance = CyGame().getSorenRandNum(200, "Random for cover prom")
			if chance >= 199:
				if (uct == uctMelee) or (uct == uctArcher) or (uct == uctGun):
					pUnit.setHasPromotion(promCover1, true)
					pUnit.setHasPromotion(promCover2, true)
			elif chance >= 195:
				if (uct == uctMelee) or (uct == uctGun):
					pUnit.setHasPromotion(promCover1, true)
			
			chance = CyGame().getSorenRandNum(200, "Random for formation prom")
			if chance >= 199:
				if (uct == uctMelee) or (uct == uctMounted) or (uct == uctGun):
					pUnit.setHasPromotion(promFormation1, true)
					pUnit.setHasPromotion(promFormation2, true)
			elif chance >= 195:
				if (uct == uctMelee) or (uct == uctGun):
					pUnit.setHasPromotion(promFormation1, true)
			
			chance = CyGame().getSorenRandNum(200, "Random for charge prom")
			if chance >= 199:
				 if (uct == uctMelee) or (uct == uctMounted) or (uct == uctArmor) or (uct == uctHeli):
					pUnit.setHasPromotion(promCharge1, true)
					pUnit.setHasPromotion(promCharge2, true)
			elif chance >= 195:
				 if (uct == uctMounted) or (uct == uctArmor) or (uct == uctHeli):
					pUnit.setHasPromotion(promCharge1, true)
			
			chance = CyGame().getSorenRandNum(200, "Random for pinch prom")
			if chance >= 199:
				 if (uct == uctGun) or (uct == uctArmor) or (uct == uctHeli):
					pUnit.setHasPromotion(promPinch1, true)
					pUnit.setHasPromotion(promPinch2, true)
			elif chance >= 195:
				 if (uct == uctGun) or (uct == uctHeli):
					pUnit.setHasPromotion(promPinch1, true)
			
			chance = CyGame().getSorenRandNum(200, "Random for ambush prom")
			if chance >= 199:
				 if (uct == uctSiege) or (uct == uctGun) or (uct == uctArmor) or (uct == uctHeli):
					pUnit.setHasPromotion(promAmbush1, true)
					pUnit.setHasPromotion(promAmbush2, true)
			elif chance >= 195:
				 if (uct == uctGun) or (uct == uctArmor) or (uct == uctHeli):
					pUnit.setHasPromotion(promAmbush1, true)
			
			chance = CyGame().getSorenRandNum(200, "Random for guerilla prom")
			if chance >= 199:
				 if (uct == uctRecon) or (uct == uctArcher) or (uct == uctGun):
					pUnit.setHasPromotion(promGuerilla2, true)
			elif chance >= 195:
				 if (uct == uctRecon) or (uct == uctMelee) or (uct == uctArcher) or (uct == uctSiege) or (uct == uctGun):
					pUnit.setHasPromotion(promGuerilla1, true)
			
			chance = CyGame().getSorenRandNum(200, "Random for woodsman prom")
			if chance >= 199:
				 if (uct == uctRecon) or (uct == uctMelee) or (uct == uctGun):
					pUnit.setHasPromotion(promWoodsman2, true)
			elif chance >= 195:
				 if (uct == uctRecon) or (uct == uctMelee) or (uct == uctArcher) or (uct == uctGun):
					pUnit.setHasPromotion(promWoodsman1, true)
					
			chance = CyGame().getSorenRandNum(100, "Random for desert/arctic/fieldsman prom")
			if chance >= 99:
				if (uct == uctRecon) or (uct == uctMelee) or (uct == uctArcher) or (uct == uctGun):
					pUnit.setHasPromotion(promWarmth, true)
			elif chance >= 98:
				if (uct == uctRecon) or (uct == uctMelee) or (uct == uctArcher) or (uct == uctGun):
					pUnit.setHasPromotion(promCold, true)
			elif chance >= 97:
				if (uct == uctRecon) or (uct == uctMelee) or (uct == uctArcher) or (uct == uctGun):
					pUnit.setHasPromotion(promField, true)
			
			chance = CyGame().getSorenRandNum(200, "Random for accuracy/barrage prom")
			if chance >= 190:
				if (uct == uctSiege):
					pUnit.setHasPromotion(promAccuracy, true)
			elif chance >= 189:
				if (uct == uctSiege) or (uct == uctArmor) or (uct == uctNaval):
					pUnit.setHasPromotion(promBarrage1, true)
					pUnit.setHasPromotion(promBarrage2, true)
			elif chance >= 185:
				if (uct == uctSiege) or (uct == uctArmor) or (uct == uctNaval):
					pUnit.setHasPromotion(promBarrage1, true)
			
			chance = CyGame().getSorenRandNum(500, "Random for drill prom")
			if chance >= 499:
				if (uct == uctArcher) or (uct == uctSiege) or (uct == uctArmor) or (uct == uctHeli) or (uct == uctNaval):
					pUnit.setHasPromotion(promDrill1, true)
					pUnit.setHasPromotion(promDrill2, true)
					pUnit.setHasPromotion(promDrill3, true)
			elif chance >= 494:
				if (uct == uctArcher) or (uct == uctSiege) or (uct == uctArmor) or (uct == uctHeli) or (uct == uctNaval):
					pUnit.setHasPromotion(promDrill1, true)
					pUnit.setHasPromotion(promDrill2, true)
			elif chance >= 469:
				if (uct == uctArcher) or (uct == uctSiege) or (uct == uctGun) or (uct == uctArmor) or (uct == uctHeli) or (uct == uctNaval):
					pUnit.setHasPromotion(promDrill1, true)
			
			chance = CyGame().getSorenRandNum(200, "Random for flanking prom")
			if chance >= 199:
				 if (uct == uctMounted) or (uct == uctArmor) or (uct == uctHeli) or (uct == uctNaval):
					pUnit.setHasPromotion(promFlanking1, true)
					pUnit.setHasPromotion(promFlanking2, true)
			elif chance >= 195:
				 if (uct == uctMounted) or (uct == uctArmor) or (uct == uctHeli) or (uct == uctNaval):
					pUnit.setHasPromotion(promFlanking1, true)
			
			chance = CyGame().getSorenRandNum(200, "Random for blitz/amphibious prom")
			if chance >= 199:
				if (uct == uctMounted) or (uct == uctArmor) or (uct == uctNaval):
					pUnit.setHasPromotion(promBlitz, true)
			elif chance >= 197:
				 if (uct == uctMelee) or (uct == uctArcher) or (uct == uctMounted) or (uct == uctSiege) or (uct == uctGun):
					pUnit.setHasPromotion(promAmph, true)
			
			chance = CyGame().getSorenRandNum(200, "Random for medic prom")
			if chance >= 199:
				 if (uct == uctRecon) or (uct == uctMelee) or (uct == uctArcher) or (uct == uctMounted) or (uct == uctSiege) or (uct == uctGun) or (uct == uctNaval):
					pUnit.setHasPromotion(promMedic1, true)
					pUnit.setHasPromotion(promMedic2, true)
			elif chance >= 195:
				 if (uct == uctRecon) or (uct == uctMelee) or (uct == uctArcher) or (uct == uctMounted) or (uct == uctGun) or (uct == uctNaval):
					pUnit.setHasPromotion(promMedic1, true)
			
			chance = CyGame().getSorenRandNum(100, "Random for heal/march prom")
			if chance >= 98:
				pUnit.setHasPromotion(promHeal, true)
			elif chance >= 97:
				 if (uct == uctRecon) or (uct == uctMelee) or (uct == uctArcher) or (uct == uctMounted) or (uct == uctSiege) or (uct == uctGun):
					pUnit.setHasPromotion(promMarch, true)
			
			chance = CyGame().getSorenRandNum(500, "Random for movement prom")
			if chance >= 495:
				if (uct == uctMounted) or (uct == uctArmor):
					pUnit.setHasPromotion(promMobility, true)
			elif chance >= 490:
				if (uct == uctRecon) or (uct == uctMelee) or (uct == uctArcher) or (uct == uctMounted) or (uct == uctGun) or (uct == uctArmor):
					pUnit.setHasPromotion(promCommando, true)
			elif chance >= 489:
				if (uct == uctRecon) or (uct == uctMounted) or (uct == uctArmor) or (uct == uctHeli):
					pUnit.setHasPromotion(promSpeed, true)
			elif chance >= 484:
				if (uct == uctNaval):
					pUnit.setHasPromotion(promNavigation, true)
			
			chance = CyGame().getSorenRandNum(100, "Random for movement prom")
			if chance >= 98:
				if (uct == uctRecon) or (uct == uctMounted) or (uct == uctHeli) or (uct == uctNaval):
					pUnit.setHasPromotion(promSentry, true)
			
				# if (uct == uctRecon) or (uct == uctMelee) or (uct == uctArcher) or (uct == uctMounted) or (uct == uctSiege) or (uct == uctGun) or (uct == uctArmor) or (uct == uctHeli) or (uct == uctNaval):