## Sid Meier's Civilization 4
## Copyright Firaxis Games 2005
##
## StackAid by Zuul
##

from CvPythonExtensions import *
import CvUtil
import Popup as PyPopup

# globals
gc = CyGlobalContext()

class StackAid:
	def updatePlot(self, iX, iY):
		promScoutAid1 = gc.getInfoTypeForString("PROMOTION_SCOUT_AID1")
		promScoutAid2 = gc.getInfoTypeForString("PROMOTION_SCOUT_AID2")
		promScoutAid3 = gc.getInfoTypeForString("PROMOTION_SCOUT_AID3")
		promMeleeAid1 = gc.getInfoTypeForString("PROMOTION_MELEE_AID1")
		promMeleeAid2 = gc.getInfoTypeForString("PROMOTION_MELEE_AID2")
		promMeleeAid3 = gc.getInfoTypeForString("PROMOTION_MELEE_AID3")
		promArcherAid1 = gc.getInfoTypeForString("PROMOTION_ARCHER_AID1")
		promArcherAid2 = gc.getInfoTypeForString("PROMOTION_ARCHER_AID2")
		promArcherAid3 = gc.getInfoTypeForString("PROMOTION_ARCHER_AID3")
		promMountedAid1 = gc.getInfoTypeForString("PROMOTION_MOUNTED_AID1")
		promMountedAid2 = gc.getInfoTypeForString("PROMOTION_MOUNTED_AID2")
		promMountedAid3 = gc.getInfoTypeForString("PROMOTION_MOUNTED_AID3")
		promSiegeAid1 = gc.getInfoTypeForString("PROMOTION_SIEGE_AID1")
		promSiegeAid2 = gc.getInfoTypeForString("PROMOTION_SIEGE_AID2")
		promSiegeAid3 = gc.getInfoTypeForString("PROMOTION_SIEGE_AID3")
		promCrowded = gc.getInfoTypeForString("PROMOTION_CROWDED")
		uctRecon = gc.getInfoTypeForString("UNITCOMBAT_RECON")
		uctArcher = gc.getInfoTypeForString("UNITCOMBAT_ARCHER")
		uctMounted = gc.getInfoTypeForString("UNITCOMBAT_MOUNTED")
		uctMelee = gc.getInfoTypeForString("UNITCOMBAT_MELEE")
		uctSiege = gc.getInfoTypeForString("UNITCOMBAT_SIEGE")
		uctGun = gc.getInfoTypeForString("UNITCOMBAT_GUN")
		uctArmor = gc.getInfoTypeForString("UNITCOMBAT_ARMOR")
		uctHelicopter = gc.getInfoTypeForString("UNITCOMBAT_HELICOPTER")

		aScout = [0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0]
		aMelee = [0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0]
		aArcher = [0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0]
		aMounted = [0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0]
		aSiege = [0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0]
		aid = 0
		pPlot = gc.getMap().plot(iX, iY)

		for i in range(0, pPlot.getNumUnits()):
			pUnit = pPlot.getUnit(i)
			uct = pUnit.getUnitCombatType()
			if (pUnit.isDead() == false):
				aid += 1
				if (uct == uctRecon) or (uct == uctHelicopter):
					aScout[pUnit.getOwner()] += pUnit.baseCombatStr()
				elif (uct == uctMelee) or (uct == uctArmor):
					aMelee[pUnit.getOwner()] += pUnit.baseCombatStr()
				elif (uct == uctArcher) or (uct == uctGun):
					aArcher[pUnit.getOwner()] += pUnit.baseCombatStr()
				elif (uct == uctMounted):
					aMounted[pUnit.getOwner()] += pUnit.baseCombatStr()
				elif (uct == uctSiege):
					aSiege[pUnit.getOwner()] += pUnit.baseCombatStr()

				
		#popup2 = PyPopup.PyPopup()
		#popup2.setBodyString('MeleeUnits at x' + str(aidX) + ' y' + str(aidY) + ' is: ' + str(aMelee[pUnit.getOwner()]))
		#popup2.launch()

		
		for i in range(0, pPlot.getNumUnits()):
			pUnit = pPlot.getUnit(i)
			uct = pUnit.getUnitCombatType()
				
			if pUnit.canAcquirePromotionAny():
				if (aid > 15):
					pUnit.setHasPromotion(promCrowded, true)
				else:
					pUnit.setHasPromotion(promCrowded, false)
				
				pUnit.setHasPromotion(promScoutAid1, false)
				pUnit.setHasPromotion(promScoutAid2, false)
				pUnit.setHasPromotion(promScoutAid3, false)
				pUnit.setHasPromotion(promMeleeAid1, false)
				pUnit.setHasPromotion(promMeleeAid2, false)
				pUnit.setHasPromotion(promMeleeAid3, false)
				pUnit.setHasPromotion(promArcherAid1, false)
				pUnit.setHasPromotion(promArcherAid2, false)
				pUnit.setHasPromotion(promArcherAid3, false)
				pUnit.setHasPromotion(promMountedAid1, false)
				pUnit.setHasPromotion(promMountedAid2, false)
				pUnit.setHasPromotion(promMountedAid3, false)
				pUnit.setHasPromotion(promSiegeAid1, false)
				pUnit.setHasPromotion(promSiegeAid2, false)
				pUnit.setHasPromotion(promSiegeAid3, false)
				
				if (uct == uctRecon) or (uct == uctHelicopter):
					totStr = aScout[pUnit.getOwner()] - pUnit.baseCombatStr()
				else:
					totStr = aScout[pUnit.getOwner()]
				if (totStr/2 > pUnit.baseCombatStr()):
					pUnit.setHasPromotion(promScoutAid3, true)
				elif (totStr > pUnit.baseCombatStr()):
					pUnit.setHasPromotion(promScoutAid2, true)
				elif (totStr*2 > pUnit.baseCombatStr()):
					pUnit.setHasPromotion(promScoutAid1, true)
				
				if (uct == uctMelee) or (uct == uctArmor):
					totStr = aMelee[pUnit.getOwner()] - pUnit.baseCombatStr()
				else:
					totStr = aMelee[pUnit.getOwner()]
				if (totStr/2 > pUnit.baseCombatStr()):
					pUnit.setHasPromotion(promMeleeAid3, true)
				elif (totStr > pUnit.baseCombatStr()):
					pUnit.setHasPromotion(promMeleeAid2, true)
				elif (totStr*2 > pUnit.baseCombatStr()):
					pUnit.setHasPromotion(promMeleeAid1, true)
				
				if (uct == uctArcher) or (uct == uctGun):
					totStr = aArcher[pUnit.getOwner()] - pUnit.baseCombatStr()
				else:
					totStr = aArcher[pUnit.getOwner()]
				if (totStr/2 > pUnit.baseCombatStr()):
					pUnit.setHasPromotion(promArcherAid3, true)
				elif (totStr > pUnit.baseCombatStr()):
					pUnit.setHasPromotion(promArcherAid2, true)
				elif (totStr*2 > pUnit.baseCombatStr()):
					pUnit.setHasPromotion(promArcherAid1, true)
				
				if (uct == uctMounted):
					totStr = aMounted[pUnit.getOwner()] - pUnit.baseCombatStr()
				else:
					totStr = aMounted[pUnit.getOwner()]
				if (totStr/2 > pUnit.baseCombatStr()):
					pUnit.setHasPromotion(promMountedAid3, true)
				elif (totStr > pUnit.baseCombatStr()):
					pUnit.setHasPromotion(promMountedAid2, true)
				elif (totStr*2 > pUnit.baseCombatStr()):
					pUnit.setHasPromotion(promMountedAid1, true)
				
				if (uct == uctSiege):
					totStr = aSiege[pUnit.getOwner()] - pUnit.baseCombatStr()
				else:
					totStr = aSiege[pUnit.getOwner()]
				if (totStr/2 > pUnit.baseCombatStr()):
					pUnit.setHasPromotion(promSiegeAid3, true)
				elif (totStr > pUnit.baseCombatStr()):
					pUnit.setHasPromotion(promSiegeAid2, true)
				elif (totStr*2 > pUnit.baseCombatStr()):
					pUnit.setHasPromotion(promSiegeAid1, true)

	def onUnitMove(self, argsList):
		'unit move'
		pPlot,pUnit = argsList
		aidX = pPlot.getX()
		aidY = pPlot.getY()
		
		self.updatePlot(aidX, aidY)
		self.updatePlot(aidX+1, aidY)
		self.updatePlot(aidX+1, aidY+1)
		self.updatePlot(aidX, aidY+1)
		self.updatePlot(aidX-1, aidY+1)
		self.updatePlot(aidX-1, aidY)
		self.updatePlot(aidX-1, aidY-1)
		self.updatePlot(aidX, aidY-1)
		self.updatePlot(aidX+1, aidY-1)
			
#	def onUnitSetXY(self, argsList):
#		pPlot,pUnit = argsList	
#		aidX = pUnit.getX()
#		aidY = pUnit.getY()
#		popup2 = PyPopup.PyPopup()
#		popup2.setBodyString('Created at: x' + str(aidX) + ' y' + str(aidY))
#		popup2.launch()
#		self.updatePlot(aidX, aidY)	
	
	def onUnitCreated(self, argsList):
		pUnit = argsList[0]
		aidX = pUnit.getX()
		aidY = pUnit.getY()
		self.updatePlot(aidX, aidY)

	def onUnitKilled(self, argsList):
		pUnit,iAttacker = argsList
		aidX = pUnit.getX()
		aidY = pUnit.getY()
		self.updatePlot(aidX, aidY)

#	def onUnitLost(self, argsList):
#		pUnit = argsList[0]	
#		aidX = pUnit.getX()
#		aidY = pUnit.getY()
#		popup2 = PyPopup.PyPopup()
#		popup2.setBodyString('Lost at: x' + str(aidX) + ' y' + str(aidY))
#		popup2.launch()
#		self.updatePlot(aidX, aidY)